import java.io.IOException;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.FloatControl;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.Mixer;
//import javax.sound.sampled.SourceDataLine;
import javax.sound.sampled.TargetDataLine;


public class Recorder extends Thread
{
	// Set Audio Format
    private static final int BITS = 8;
    private static final int HZ = 44100;//CD=44100 DVD=48000Hz
    private static final int MONO = 1;
   
    private TargetDataLine mTarget;
    private AudioInputStream mStream;
    private volatile int mRawGeigerCount = 0;
    private byte mDebugSoundMax = 0 ; 

    public boolean g_bRecorder = false;

    
    // RXgN^
    Recorder()
    {
        // I[fBItH[}bg̎w
        AudioFormat linear = new AudioFormat( HZ, BITS, MONO, true, false );
        mStream = captureAudio(linear);
        g_bRecorder = true;

        //FloatControl volCtrl ;
        //volCtrl = (FloatControl) mTarget.getControl(  FloatControl.Type.VOLUME);
        //float maxVol = volCtrl.getMaximum() ;
        //volCtrl.setValue(maxVol);
           
    }

    // Xbhs
    public void run()
    {
    	final byte detectThreshold = 70;//WDM-004+GalaxyS
    	final byte lowLevelPlus = detectThreshold / 3 ;
		final int ignoreCount = 20;// 1pulseẮǍ̔g`𖳎Bg`́A0.2msec

		int remain = 0 ;
		int i ; // Iɍ肽Ȃ̂łɒu(ӖȂ)
		byte value;// Iɍ肽Ȃ̂łɒu(ӖȂ)

	    // PCM
	    byte[] voiceBuffer = new byte[ HZ * BITS / 8 * MONO ];
		
        while( true )  {
            if( !g_bRecorder ) return;
            try  {
                // Xg[特f[^擾
                mStream.read( voiceBuffer , 0, voiceBuffer.length );
                for( i = 0 ; i < voiceBuffer.length ; i ++ ) {
                	value = voiceBuffer[i];
                	if( value < 0 ) {
                		value = (byte) - value ;
                	}
	                //fobOp
					if( value > mDebugSoundMax ) {
						mDebugSoundMax = value ;
					}
	                //܂ŃfobOp

					//g`̎c肩́A]Ȃ悤ɂ
					if (remain > 0) {
						//System.out.println(">");
				    	if(  value < lowLevelPlus ) {
							remain--;//xႢꍇɂ́Aremain 
						}
						else {
							remain = ignoreCount;//xႭȂꍇɂ́AēxxႭȂ܂ő҂
						}
						continue ;
					}
					if( value > detectThreshold) {
						//pXo
						mRawGeigerCount++;
						//System.out.print(mRawGeigerCount+",");
						remain = ignoreCount;
					}
                }
               
            } 
            catch (IOException e)  {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
            // ꉞAEGCg
            try{
                Thread.sleep( 1 );
            } catch (InterruptedException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
    }
    public int getCount()
    {
    	return mRawGeigerCount ;
    }
   
    public byte getMax()
    {
    	byte temp ;
    	temp = mDebugSoundMax ;
    	mDebugSoundMax = 0 ;
    	return temp ;
    }
    // I
    public void end()
    {
        g_bRecorder = false;
       
        // ^[Qbgf[^C~
        mTarget.stop();
       
        // ^[Qbgf[^C
        mTarget.close();
    }
    /**
     * linear tH[}bgŃI[vł~LT[IA AudioInputStream@Ԃ
     * @param linear
     */
    private AudioInputStream captureAudio(AudioFormat linear ){
        Mixer.Info[] mixerInfo = AudioSystem.getMixerInfo();
        Mixer mixer ;
        for(int cnt = 0; cnt < mixerInfo.length; cnt++){
          	System.out.println(mixerInfo[cnt].getName());
            // ^[Qbgf[^C擾
            DataLine.Info info = new DataLine.Info( TargetDataLine.class, linear );
            boolean error = true ;
        	mixer = AudioSystem.getMixer(mixerInfo[cnt] ) ;
        	try {
        		mTarget = (TargetDataLine) mixer.getLine(info);
        		error = false ;
        	} catch (LineUnavailableException e) {
        		// TODO Auto-generated catch block
        		//e.printStackTrace();
        	}
            catch (IllegalArgumentException e)  {
                // TODO Auto-generated catch block
                //e.printStackTrace();
            }
            if( error == false ) {
            	break ;
            }
        }//end for loop
        // ^[Qbgf[^CJ
        try {
			mTarget.open(linear);
		} catch (LineUnavailableException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
   
        // }CN͊Jn
        mTarget.start();
   
        // ̓Xg[擾
        AudioInputStream  stream = new AudioInputStream( mTarget );
        return stream ;
    }
}

