//package TextEditor;
//http://codezine.jp/article/detail/2597?p=7
//http://codezine.jp/article/detail/2543
//http://wisdom.sakura.ne.jp/system/java/swing/
//http://www.javadrive.jp/applet/thread/index8.html
//http://www.marutsu.co.jp/shohin_59600/ mvO
//http://www.marutsu.co.jp/shohin_10402/ 4ɃvO

import java.awt.*;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.*;
import java.util.Timer;
import java.util.TimerTask;

class SoundGeiger extends JFrame  {
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Timer mTimer ;
	Recorder mRec ;
	volatile long mSumOfCount  = 0 ;
	boolean mIsEffectiveData = false ;
	static final int MEASURE_SEC = 60 ;
	static final int HISTORY_MAX = 120;
	int mCountDown = HISTORY_MAX ;

    public static void main(String[] args) {
        // g̃CX^X
        new SoundGeiger();
    }

    // RXgN^
    //@SuppressWarnings("deprecation")
	SoundGeiger(){
        // X[p[NX̃RXgN^Ăяo
        super("KCK[JE^");
        
        //pXoNX(Xbh)
    	mRec = new Recorder() ;
    	mRec.start();
    	mRec.getCount();
    	
    	//ړϓsXbh
    	mTimer = new Timer() ;
    	mTimer.schedule(new MyIntervalTimerTask(), 0, 500);
    	
    	//t[̏
        this.setSize(800, 600);
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setVisible(true);

        //L[͎擾pݒ
        KeyListener ekey=new KeyListener();
        this.addKeyListener(ekey);
        
        repaint();

        
/*
        // plɕiǉ
        //JPanel panel = new JPanel();
        this.add(open);
        this.add(save);
*/
    }
    class MyIntervalTimerTask extends TimerTask {

		int[] mHistry = new int[HISTORY_MAX];
		int mHistryPtr = 0;
		long rawLastGeigerCnt = 0 ;

    	@Override
		public void run() {
			// OƂ̍߂
			long totalGeigerCount = mRec.getCount();//݂̃g[^JEgl
			long deltaGeiger = totalGeigerCount - rawLastGeigerCnt;
			rawLastGeigerCnt = totalGeigerCount;

			// ߋԕ̃JEgl߂
			mSumOfCount -= mHistry[mHistryPtr];
			mSumOfCount += deltaGeiger;
			mHistry[mHistryPtr] = (int)deltaGeiger;
			mHistryPtr = incrimentHistryPtr(mHistryPtr);
			mCountDown -- ;
			if (mHistryPtr == 0) {
				//ꏄAf[^LƌȂ
				mIsEffectiveData = true;
			}
			//܂łŁAmSumOfCount ̒l܂
			repaint();
			
		}
		int incrimentHistryPtr(int ptr) {
			ptr++;
			if (ptr >= mHistry.length) {
				ptr = 0;
			}
			return ptr;
		}
    }
    @Override
    public void paint(Graphics g) {
    	//_uobt@Oŕ`
        Dimension size = getSize();
        Image back = createImage(size.width, size.height);
        Graphics buffer = back.getGraphics() ;

        buffer.setColor(getBackground());
        buffer.fillRect(0, 0, size.width, size.height);
        
        String dataString ;
        if( mIsEffectiveData == false) {
        	dataString = "΂炭҂"+ ( mCountDown / 2 ) ;
        }
        else {
        	System.out.println("<"+mSumOfCount+">");
        	double value = mSumOfCount * 0.360 / MEASURE_SEC  ;//360.0 ͌oIȒl
        	dataString = String.format("%3.2fSv/h ",value);
        }
        Font font = new Font("Default",Font.PLAIN, 40);
        buffer.setFont(font) ;
        buffer.setColor(Color.RED);
        buffer.drawString(dataString,50,100);

        dataString = String.format("%d", mSumOfCount);
        dataString += " CPM " ;
        buffer.setColor(Color.BLACK);
        buffer.drawString(dataString,50,140);
        
        dataString = "sound peak = " + mRec.getMax() ;  
        buffer.setColor(Color.BLACK);
        buffer.drawString(dataString,50,180);
        
        g.drawImage(back,0,0,this);
        //g.dispose();
    }
    //L[͂ɊւNX
    class KeyListener extends KeyAdapter{
    	//L[
      public void keyPressed(KeyEvent e){
        char c=e.getKeyChar();
        System.out.println("" + c);
      }
    }
}
